// InfoBot.cpp
//
// 20000818 / dhartmei - initial revision
// 20000905 / dhartmei - select timeout increased 250 -> 1000
//

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <iostream>
#include <string>
#include <vector>
#ifdef __WIN32__
  #include <dos.h>
#else
  #include <unistd.h>
#endif
#include "IRC.hpp"

// ----------------------------------------------------------------------------

bool terminated = false;
char timestring[20];
ofstream *file = 0;

// ----------------------------------------------------------------------------

void updateTime()
  {
    time_t t = time(0);
    tm *tm = localtime(&t);
    sprintf(timestring, "%4.4i.%2.2i.%2.2i %2.2i:%2.2i:%2.2i", tm->tm_year+1900, tm->tm_mon+1, tm->tm_mday, tm->tm_hour, tm->tm_min, tm->tm_sec);
    return;
  }

// ----------------------------------------------------------------------------

void syslog(std::string msg)
  {
    if (file && file->good())
      {
        updateTime();
        *file << timestring << ' ' << msg << '\n';
        file->flush();
      }
    return;
  }

// ----------------------------------------------------------------------------

int main(int argc, char *argv[])
  {
    if (argc != 4) { cerr << argv[0] << " <server> <port> <nick>" << endl; return 1; }

    cout << "InfoBot starting (server " << argv[1] << ", port " << atoi(argv[2]) << ", nick " << argv[3] << ")" << endl;
    updateTime();
    srand(time(0));

    file = new ofstream("InfoBot.log", ios::out|ios::app);
    syslog("################ InfoBot log file openend #################");

    char vhost[1024]; vhost[0] = 0;
    ifstream *ifvhost = new ifstream("InfoBot.vhost");
    if (ifvhost->good()) ifvhost->getline(vhost, 1023);
    delete ifvhost;

    if (!InitializeSockets()) return 1;

    IRCSocket s(argv[1], atoi(argv[2]), vhost, argv[3]);
    while (!terminated)
      {
        syslog("*** connecting");
        if (s.connect())
          {
            syslog("*** connected and ready");
            while (s.select(1000)) {}
            s.disconnect();
            syslog("*** disconnected");
          }
        if (!terminated) { syslog("*** waiting 30 seconds before re-connecting"); sleep(30); }
      }

    CleanupSockets();

    syslog("################# InfoBot log file closed #################\n");
    file->close(); delete file; file = 0;

    return 0;
  }

// ----------------------------------------------------------------------------

