// LineSock.hpp
//
// 20000818 / dhartmei - initial revision
//

#ifndef LINESOCK_HPP
#define LINESOCK_HPP

#include <string>

// ----------------------------------------------------------------------------

bool InitializeSockets();
void CleanupSockets();

// ----------------------------------------------------------------------------

class StreamSocket
  {
    public:
      StreamSocket(const char *address, unsigned port, const char *vhost);
      virtual ~StreamSocket();
      virtual bool connect();
      virtual void disconnect();
      virtual bool select(unsigned timeout = 0);
      virtual void recv(const char *data) = 0;
      virtual void send(const char *data);
    protected:
      char *address, *vhost;
      unsigned port;
      int s;
  };

// ----------------------------------------------------------------------------

class LineSocket : public StreamSocket
  {
    public:
      LineSocket(const char *address, unsigned port, const char *vhost);
      virtual void recv(const char *data);
      virtual void recvLine(std::string line) = 0;
      virtual void sendLine(std::string line);
    protected:
      std::string line;
  };

// ----------------------------------------------------------------------------

#endif

